=== debian/changelog ===
fluidsynth (2.4.8+dfsg-1) unstable; urgency=medium

  * New upstream version 2.4.8+dfsg

 -- Dennis Braun <snd@debian.org>  Thu, 02 Oct 2025 18:44:21 +0200
