=== debian/tests/control ===
Tests: build
Depends: build-essential, libfluidsynth-dev, libpulse-dev
Restrictions: allow-stderr
