=== debian/watch ===
version=4
opts=uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)\d*)$/$1~$2/,dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,repack,repacksuffix=+dfsg,compression=xz \
https://github.com/Fluidsynth/fluidsynth/tags .*/v(\d.*)@ARCHIVE_EXT@
